﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ImageViewHour, ImageViewMinute, ImageViewSecond As ImageView
	Private Timer1 As Timer
	Private Day As Int
	Private LblDate As Label
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	'Version 1.1 - 2024/06/27
	Timer1.Initialize("Timer1", 50)
	Timer1.Enabled = True
	Timer1_Tick
End Sub

Sub Timer1_Tick
	Dim now As Long = DateTime.Now
	' Seconds
	Dim seconds As Float = (now Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond
	NeedleRotate(ImageViewSecond, TimeToDegree(seconds, False))
	' Minutes
	Dim currentMinutes As Float = DateTime.GetMinute(now) + (seconds / 60)
	NeedleRotate(ImageViewMinute, TimeToDegree(currentMinutes, False))
	' Hours
	Dim currentHour As Float = DateTime.GetHour(now)
	Dim hourAngle As Float = ((currentHour Mod 12) + (currentMinutes / 60)) * 30
	NeedleRotate(ImageViewHour, hourAngle)
	' Date
	Dim currentDay As Int = DateTime.GetDayOfMonth(now)
	If currentDay <> Day Then
		Day = currentDay
		LblDate.Text = Day
	End If
End Sub

Sub TimeToDegree(value As Float, isHour As Boolean) As Float
	Return (value / IIf(isHour, 12, 60)) * 360
End Sub

Sub NeedleRotate(iv As ImageView, degree As Float)
	Dim jo As JavaObject = iv
	jo.RunMethod("setRotation", Array(degree))
End Sub
